/******************************************************************************
 * C-BUNG 05
 * Bitoperationen
 *           
 * (c) 2003, by Jan Iversen und Andreas Schibilla
 *****************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <stddef.h>
#include <string.h>
#include "mengen.h"
#include "sometools.h"

#define  MAX_FILENAME   255
#define  EXTENSION      ".bga"


/******************************************************************************
 * Zhlt die Bits in der Datei filename und speichert in nullen und einsen
 *****************************************************************************/
void countbits(char * filename, int * nullen, int * einsen)
{
 FILE    * file;
 int     ch;

 file = fopen(filename, "rb");
 if (file == NULL)
    {
      printf("Fehler beim ffnen der Datei: %s\n", filename);
      exit(1);
    }
 while ( (ch = fgetc(file) )  >= 0 )            /* lese jeweils ein Zeichen */
    {
      ch = cardinality ( (char) ch );           /* wieviele Bits sind gesetzt ? */
      *einsen += ch;
      *nullen += 8-ch;
    }
 fclose(file);
 return;
}


/******************************************************************************
 * Ermittelt das erste Byte, das in die Datei geschrieben werden soll
 * -> differenz   - gibt an, wieviele Bits der Unterschied ist
 * -> flag        - true=mehr Einsen, false=mehr Nullen in die Datei!
 *****************************************************************************/
int firstbyte(int differenz, int flag)
{
 int einsen, i;

 i = differenz % 8;                             /* Differnez des letzten Bytes */
 einsen = flag ? i : 0;                         /* wenn mehr Einsen sein sollen schon vorinitialisieren */
 einsen += (8-i) / 2;                           /* Rest-Bits des Bytes werden aufgeteilt, wieviele Einsen? */

 return 255 << (8-einsen);                      /* setze alle Bits und schiebe Nullen rein */
}


/******************************************************************************
 * Schreibt die Bits in die Datei filename
 * -> differenz   - gibt an, wieviele Bits der Unterschied ist
 * -> flag        - true=mehr Einsen, false=mehr Nullen in die Datei!
 *****************************************************************************/
void writebits(char * filename, int differenz, int flag)
{
 FILE * file;
 int bytes;

 file = fopen(filename, "wb");
 if (file == NULL)
    {
      printf("Fehler beim ffnen der Datei: %s\n", filename);
      exit(1);
    }

 if (differenz % 8)
   fputc(firstbyte(differenz, flag), file);     /* schreibe erstes Byte */
 bytes = differenz / 8;                         /* wieviele weite Bytes */
 while(bytes)
   {
      fputc(flag ? 255 : 0 , file);             /* flle mit gesetzten oder leeren Bytes auf */
      --bytes;
   }
 fclose(file);
 return;
}


/******************************************************************************
 * berprft ob String "-h" oder "-H" ist
 * 
 * p              -  Zeiger auf Anfang des Strings
 *           
 * Die Fkt. gibt zurck, ob String einer der o. g. ist
 *****************************************************************************/
int checkparam1 (char * p)
{
 return (strlen(p)==2) && (p[0]=='-') && ( (p[1]=='h') || (p[1]=='H') );
}


/******************************************************************************
 * Gibt die Hilfe aus
 *           
 *****************************************************************************/
void ShowUsage (void)
{
  printf("usage: ueb05 [-h, -H, Datei]\n");
  printf("        -h: Hilfe\n");
}


/******************************************************************************
 * Sorgt fr einen Ploarittsausgleich 
 *****************************************************************************/
int main (int argc, char *argv[])
{
 int nullen=0, einsen=0;
 char str[MAX_FILENAME];


  if (argc != 2)                                /* falsche Parameteranzahl */
    {      
      ShowUsage();
      return 1;
    }
  if (checkparam1(argv[1]) != 0)                /* Hilfe gewollt ausgeben */
    {
      ShowUsage();
      return 0;
    }

  countbits(argv[1], &nullen, &einsen);         /* bits zhlen */
  if (nullen == einsen)
   {
      printf("Die Quelldatei ist bereits ausgeglichen!\n");
      exit(0);
   }

  strcpy(str, extractfilename(argv[1]));        
  strcat(str, EXTENSION);
  writebits(str, nullen>einsen ? nullen-einsen : einsen-nullen, nullen>einsen);

  return 0;
}
